#  Copyright (C) 1999-2009
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

# Menu

proc HelpMenu {varname} {
    upvar $varname var

    $var add cascade -label [msgcat::mc {Help}] -menu $var.help

    menu $var.help
    $var.help add command -label [msgcat::mc {Reference Manual}]\
	-command HelpRef
    $var.help add command -label [msgcat::mc {User Manual}]\
	-command HelpUser
    $var.help add command -label [msgcat::mc {Keyboard Shortcuts}] \
	-command HelpKeyboard
    $var.help add separator
    $var.help add command -label [msgcat::mc {FAQ}] \
	-command HelpFAQ
    $var.help add command -label [msgcat::mc {New Features}] \
	-command HelpNew
    $var.help add command -label [msgcat::mc {Known Issues}] \
	-command HelpIssue
    $var.help add command -label [msgcat::mc {Release Notes}] \
	-command HelpRelease
    $var.help add command -label [msgcat::mc {Help Desk}] \
	-command HelpDesk
    $var.help add separator
    $var.help add command -label [msgcat::mc {Acknowledgment}] \
	-command HelpAck
    $var.help add command -label [msgcat::mc {DS9 Home Page}] \
	-command HelpHome
}

proc PrefsDialogHelp {} {
    global prefs

    set w $prefs(tabs)

    frame $w.help
    $prefs(tabs) tab configure help -window $w.help -fill both

    frame $w.help.menu -relief ridge -bd 1
    pack $w.help.menu -side top -fill both -expand true

    # Buttons
    PrefsDialogButtons $w.help

    # Default Menu
    set f $w.help.menu.f
    frame $f
    pack $f -anchor w -fill y -expand true

    label $f.title -text [msgcat::mc {Default}]
    PrefsDialogButtonbarHelp $f.buttonbar

    grid $f.title $f.buttonbar -padx 4 -sticky w
}

# Buttons

proc ButtonsHelpDef {} {
    global pbuttons

    array set pbuttons {
	help,ref 1
	help,user 1
	help,keyboard 1
	help,faq 0
	help,new 0
	help,issue 0
	help,release 1
	help,desk 1
	help,ack 1
	help,home 1
    }
}

proc CreateButtonsHelp {} {
    global buttons
    global ds9

    frame $ds9(buttons).help

    ButtonButton $ds9(buttons).help.ref \
	[string tolower [msgcat::mc {Reference}]] HelpRef
    ButtonButton $ds9(buttons).help.user \
	[string tolower [msgcat::mc {User}]] HelpUser
    ButtonButton $ds9(buttons).help.keyboard \
	[string tolower [msgcat::mc {Keyboard}]] HelpKeyboard
    ButtonButton $ds9(buttons).help.faq \
	[string tolower [msgcat::mc {FAQ}]] HelpFAQ
    ButtonButton $ds9(buttons).help.new \
	[string tolower [msgcat::mc {New Features}]] HelpNew
    ButtonButton $ds9(buttons).help.issue \
	[string tolower [msgcat::mc {Known Issues}]] HelpIssue
    ButtonButton $ds9(buttons).help.release \
	[string tolower [msgcat::mc {Release}]] HelpRelease
    ButtonButton $ds9(buttons).help.desk \
	[string tolower [msgcat::mc {Help Desk}]] HelpDesk
    ButtonButton $ds9(buttons).help.ack \
	[string tolower [msgcat::mc {Acknowledgment}]] HelpAck
    ButtonButton $ds9(buttons).help.home \
	[string tolower [msgcat::mc {Home}]] HelpHome

    set buttons(help) "
        $ds9(buttons).help.ref pbuttons(help,ref)
        $ds9(buttons).help.user pbuttons(help,user)
        $ds9(buttons).help.keyboard pbuttons(help,keyboard)
        $ds9(buttons).help.faq pbuttons(help,faq)
        $ds9(buttons).help.new pbuttons(help,new)
        $ds9(buttons).help.issue pbuttons(help,issue)
        $ds9(buttons).help.release pbuttons(help,release)
        $ds9(buttons).help.desk pbuttons(help,desk)
        $ds9(buttons).help.ack pbuttons(help,ack)
        $ds9(buttons).help.home pbuttons(help,home)
    "
}

proc PrefsDialogButtonbarHelp {f} {
    global buttons
    global pbuttons

    menubutton $f -relief raised -text [msgcat::mc {Buttonbar}] -menu $f.menu
    
    set m $f.menu
    menu $m
    $m add checkbutton -label [msgcat::mc {Reference Manual}]\
	-variable pbuttons(help,ref) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {User Manual}]\
	-variable pbuttons(help,user) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Keyboard Shortcuts}] \
	-variable pbuttons(help,keyboard) -command {UpdateButtons buttons(help)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {FAQ}] \
	-variable pbuttons(help,faq) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {New Features}] \
	-variable pbuttons(help,new) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Known Issues}] \
	-variable pbuttons(help,issue) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Release Notes}] \
	-variable pbuttons(help,release) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {Help Desk}] \
	-variable pbuttons(help,desk) -command {UpdateButtons buttons(help)}
    $m add separator
    $m add checkbutton -label [msgcat::mc {Acknowledgment}] \
	-variable pbuttons(help,ack) -command {UpdateButtons buttons(help)}
    $m add checkbutton -label [msgcat::mc {DS9 Home Page}] \
	-variable pbuttons(help,home) -command {UpdateButtons buttons(help)}
}
