#  Copyright (C) 1999-2009
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc DS9Def {} {
    global ds9
    global pds9

    set ds9(title) "$ds9(app)"
    set ds9(version) {5.7}

    set ds9(top) .
    set ds9(mb) .mb

    set ds9(visual) {}
    set ds9(depth) 8

    set ds9(main) {}
    set ds9(image) {}
    set ds9(canvas) {}
    set ds9(panel) {}
    set ds9(info) {}
    set ds9(panner) {}
    set ds9(magnifier) {}
    set ds9(buttons) {}
    set ds9(graph,sp) {}
    set ds9(graph,horz) {}
    set ds9(graph,vert) {}

    set ds9(frames) {}
    set ds9(active) {}
    set ds9(active,num) 0
    set ds9(lock) 0
    set ds9(next) {}
    set ds9(next,num) 1
    set ds9(mode) pointer

    set ds9(event,opendoc) {}
    set ds9(event,printdoc) {}

    switch $ds9(wm) {
	x11 {set ds9(dialog) motif}
	win32 {set ds9(dialog) native}
	aqua {set ds9(dialog) native}
    }
    set ds9(dialog,dir) {}

    switch $ds9(wm) {
	x11 -
	win32 {
	    set ds9(menu,start) 1
	}
	aqua {
	    set ds9(menu,start) 0
	}
    }
    set ds9(menu,size,frame,goto) [expr $ds9(menu,start)+0]
    set ds9(menu,size,frame,active) [expr $ds9(menu,start)+3]
    set ds9(menu,size,analysis) [expr $ds9(menu,start)+28]
    set ds9(menu,size,file,samp) [expr $ds9(menu,start)+2]
    set ds9(menu,size,wrap) 20

    set ds9(display,mode) single
    set ds9(display,user) single
    set ds9(automarker) 1
    set ds9(confirm) 1

    set ds9(bg) white
    set ds9(bg,color) white
    set ds9(nan,color) white

    set ds9(tcl) 0

    set ds9(idletasks) 1

    set ds9(msg,src) {}
    set ds9(msg,level) {}
    set ds9(msg) {}

    set ds9(xpa) 1

    set ds9(samp) 0
    set ds9(samp,auto) 1
    set ds9(samp,timeout) 1000

    set ds9(internalpad) 2
    set ds9(row) -1
    set ds9(freeze) 0

    set ds9(imexam) 0
    set ds9(imexam,key) 0
    set ds9(imexam,any) 0
    set ds9(imexam,frame) {}
    set ds9(imexam,x) {}
    set ds9(imexam,y) {}
    set ds9(imexam,event) {}
    set ds9(imexam,mode) {}

    set ds9(b1) 0
    set ds9(b2) 0
    set ds9(b3) 0

    set ds9(sb1) 0
    set ds9(sb2) 0
    set ds9(sb3) 0

    set ds9(cb1) 0
    set ds9(cb2) 0
    set ds9(cb3) 0

    set ds9(csb1) 0
    set ds9(csb2) 0
    set ds9(csb3) 0

    set ds9(modifier) 0

    set ds9(ext,file) ".$ds9(app).fil"
    set ds9(ext,alt) ".$ds9(app).file"
    set ds9(analysis,file) ".$ds9(app).ans"
    set ds9(analysis,alt) ".$ds9(app).analysis"
    set ds9(analysis,user) {}
    set ds9(analysis,user2) {}
    set ds9(analysis,user3) {}
    set ds9(analysis,user4) {}

    set ds9(array,x) 512
    set ds9(array,y) 512
#    set ds9(array,z) 1
    set ds9(array,bitpix) -32
    set ds9(array,skip) 0
    set ds9(array,arch) bigendian

    set ds9(fileProcs) {Stdin ExternalFits GzipFits BZip2Fits CompressFits PackFits FTZFits}

    set ds9(language) locale
    set ds9(language,name) [LanguageToName $ds9(language)]
    set ds9(language,dir) {}

    switch $ds9(wm) {
	x11 {
	    set ds9(font) default
	    set ds9(font,size) 10
	    set ds9(font,style) normal
	}
	win32 {
	    set ds9(font) default
	    set ds9(font,size) 10
	    set ds9(font,style) normal
	}
	aqua {
	    set ds9(font) default
	    set ds9(font,size) 10
	    set ds9(font,style) normal
	}
    }

    switch $ds9(wm) {
	x11 {
	    set ds9(ctrl) "Control-"
	    set ds9(shiftctrl) "Shift-Control-"
	}
	win32 {
	    set ds9(ctrl) "Control-"
	    set ds9(shiftctrl) "Control-"
	} 
	aqua {
	    set ds9(ctrl) "Command-"
	    set ds9(shiftctrl) "Shift-Command-"
	}
    }

    set pds9(mode) $ds9(mode)
}

proc CurrentDef {} {
    global current
    global pcurrent

    set current(frame) {}
    set current(ext) {}
    set current(colorbar) {}
    set current(cursor) {}
    set current(zoom) { 1 1 }
    set current(rotate) 0
    set current(orient) none
    set current(rgb) red

    set pcurrent(zoom) $current(zoom)
    set pcurrent(orient) $current(orient)
    set pcurrent(rotate) $current(rotate)
}

proc HTTPDef {} {
    global http

    set http(proxy) 0
    set http(proxy,host) {}
    set http(proxy,port) {}
    set http(auth) 0
    set http(auth,user) {}
    set http(auth,passwd) {}
    set http(timeout) 240000
}

proc CursorDef {} {
    global cursor

    set cursor(save) {}
    set cursor(count) 0
    set cursor(id) 0
    set cursor(timer) 0
    set cursor(timer,abort) 0
}

proc CoordDef {} {
    global coord

    set coord(value) 1
    set coord(image) 1
    set coord(physical) 0
    set coord(amplifier) 0
    set coord(detector) 0
    set coord(wcs) 1
    foreach l {a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	set "coord(wcs$l)" 0
    }
    set coord(sky) fk5
    set coord(skyformat) sexagesimal
}

proc UpdateDS9Static {} {
    # This routine is only called when an frame is added or deleted
    # we only change menu items which require at least one frame

    global debug
    if {$debug(tcl,update)} {
 	puts stderr "UpdateDS9Static begin..."
    }

    UpdateFileMenuStatic
    UpdateFrameMenuStatic
    UpdateZoomMenuStatic
    UpdateAnalysisMenuStatic
    
    if {$debug(tcl,update)} {
 	puts stderr "UpdateDS9Static end...\n"
    }
}

proc UpdateDS9 {} {
    # This routine is called when ever there is a state change within ds9
    # for example, a image is loaded, current(frame) is changed, etc

    global ds9
    global debug
    if {$debug(tcl,update)} {
	puts stderr "UpdateDS9 begin..."
    }

    # we have a problem with windows menus updated rapidly
    # so disable menu updates while in blink mode

    if {!($ds9(wm) == {win32} && $ds9(display,user) == {blink})} {
	UpdateFileMenu
	UpdateEditMenu
	UpdateFrameMenu
	UpdateBinMenu
	UpdateZoomMenu
	UpdateScaleMenu
	UpdateColorMenu
	UpdateRegionMenu
	UpdateWCSMenu
	UpdateAnalysisMenu

	UpdateMaskMenu
	UpdateContourMenu
	UpdateGridMenu
	UpdateSmoothMenu
    }

    UpdateCubeDialog
    UpdateRGBDialog
    Update3DDialog
    UpdateBinDialog
    UpdateZoomDialog
    UpdateScaleDialog
    UpdateColorDialog
    UpdateGroupDialog
    UpdateCATDialog
    UpdateCentroidDialog

    UpdateMaskDialog
    UpdateContourDialog
    UpdateGridDialog
    UpdateSmoothDialog

    UpdateGraphXAxis
    UpdateGraphYAxis

    RefreshInfoBoxCurrent
    UpdateColormapLevel
    
    if {$debug(tcl,update)} {
	puts stderr "UpdateDS9 end...\n"
    }
}

# changes to other dialogs can affect the infobox and pixeltable
proc UpdateMain {} {
    global debug
    if {$debug(tcl,update)} {
	puts stderr "UpdateMain"
    }

    global ds9
    switch -- $ds9(mode) {
	crosshair {
	    global current
	    if {$current(frame) != {}} {
		set coord [$current(frame) get crosshair canvas]
		set x [lindex $coord 0]
		set y [lindex $coord 1]

		UpdateColormapLevel
		# just in case we hae a mosaic
		UpdateColormapLevelMosaic $current(frame) $x $y canvas

		UpdateInfoBox $current(frame) $x $y canvas
		UpdatePixelTableDialog $current(frame) $x $y canvas
		UpdateGraph $current(frame) $x $y canvas
	    }
	}
	none -
	pointer -
	catalog -
	colorbar -
	pan -
	zoom -
	rotate -
	examine -
	illustrate -
	imexam {
	    UpdateColormapLevel
	    RefreshInfoBoxCurrent
	}
    }
}

# capture general errors
# this only captures gui errors, not xpa errors
proc bgerror {err} {
    global cursor

    tk_messageBox -type ok -icon error \
	-message "[msgcat::mc {An internal error has been detected}] $err"

    # reset cursor
    set cursor(count) 0
    UnsetWatchCursor
}

# force capture xpa/samp/hv/interactive errors
proc InitError {which} {
    global ds9
    global errorInfo

    set ds9(msg,src) $which
    set ds9(msg,level) {}
    set ds9(msg) {}
    set errorInfo {}
}

proc Error {message} {
    ProcessMessage error $message
}

proc Info {message} {
    ProcessMessage info $message
}

proc ProcessMessage {which message} {
    global ds9
    global errorInfo

    set ds9(msg,level) $which
    switch -- $ds9(msg,src) {
	xpa -
	hv -
	samp {set ds9(msg) $message}
	default {tk_messageBox -message $message -type ok -icon $which}
    }
}

proc ProcessSend {proc id sock fn ext rr} {
    if {$sock != {}} {
	# not implemented
    } elseif {$fn != {}} {
	append fn $ext
	set ch [open $fn w]
	puts $ch $rr
	close $ch
	$proc $id {} $fn
    } else {
	$proc $id $rr
    }
}

proc GetFileURL {url fname} {
    upvar $fname fn

    ParseURL $url rr
    switch -- $rr(scheme) {
	ftp {GetFileFTP $rr(authority) $rr(path) $fn}
	file {set fn $rr(path)}
	http -
	default {GetFileHTTP $url $fn}
    }
}

proc GetFileFTP {host path fn} {
    global debug

    set ftp [ftp::Open $host {ftp} {-ds9@} -mode passive]
    if {$ftp > -1} {
	set ftp::VERBOSE $debug(tcl,ftp)
	set "ftp::ftp${ftp}(Output)" FTPLog
	ftp::Type $ftp binary
	ftp::Get $ftp $path $fn
	ftp::Close $ftp

	# clear error from tcllib ftp
	global errorInfo
	set errorInfo {}
    }
}

proc GetFileHTTP {url fn} {
    global http

    set ch [open $fn w]
    if [catch {http::geturl $url -timeout $http(timeout) -channel $ch -binary 1 -headers "[ProxyHTTP]"} token] {
	close $ch
	return
    }
    close $ch
    HTTPLog $token
    http::cleanup $token
}

proc SourceInitFile {ext} {
    global ds9
    global env
    
    foreach ff {{.} {}} {
	set fn $ff$ds9(app)$ext
	foreach dir [list {.} [GetEnvHome] {/usr/local/lib} {/opt/local/lib}] {
	    set ff [file join $dir $fn]
	    if [file exist $ff] {
		# can't make this a debug command line option
		# prefs set before options parsed
		if [catch {source $ff}] {
		    Error "[msgcat::mc {An error has occured while executing}] $ff. [msgcat::mc {DS9 will complete the initialization process}]"
		}
		return
	    }
	}
    }
}

proc DeleteInitFile {ext} {
    global ds9
    global env
    
    foreach ff {{.} {}} {
	set fn $ff$ds9(app)$ext
	foreach dir [list {.} [GetEnvHome]] {
	    set ff [file join $dir $fn]
	    if [file exist $ff] {
		catch {file delete -force $ff}
		return
	    }
	}
    }
}

proc LanguageToName {which} {
    global ds9

    switch $which {
	locale {return {Locale}}
	da {return {Dansk}}
	de {return {Deutsch}}
	en {return {English}}
	es {return [encoding convertfrom iso8859-1 {Espaol}]}
	fr {return [encoding convertfrom iso8859-1 {Franais}]}
	ja {return [encoding convertfrom euc-jp "\xc6\xfc\xcb\xdc\xb8\xec"]}
	pt {return [encoding convertfrom iso8859-1 {Portugus}]}
	zh {return [encoding convertfrom big5 "\xA4\xA4\xA4\xE5"]}
    }
}

proc SetLanguage {ll} {
    global ds9
    
    set ds9(language,name) [LanguageToName $ll]

    set x 0
    msgcat::mclocale $ll

    msgcat::mcload [file join $::tk_library msgs]

    # we need to find if we support this language
    if [msgcat::mcload [file join $ds9(root) msgs]] {
	incr x
    }
    if {$ds9(language,dir) != {}} {
	if [msgcat::mcload $ds9(language,dir)] {
	    incr x
	}
    }

    # if english, always return found
    if {![string compare [string range $ll 0 1] {en}]} {
	incr x
    }

    if {$x} {
	return 1
    } else {
	return 0
    }
}

proc GetEnvHome {} {
    global env

    # return current directory by default
    set home {}

    global tcl_platform
    switch $tcl_platform(platform) {
	unix {
	    if [info exists env(HOME)] {
		set home $env(HOME)
	    }
	}
	windows {
	    if {[info exists env(HOME)]} {
		set hh [file normalize [file nativename $env(HOME)]]
		if [file isdirectory $hh] {
		    set home $hh
		}
	    }
	    # this is just a backup, the above should always work
	    if {$home == {} &&
		[info exists env(HOMEDRIVE)] &&
		[info exists env(HOMEPATH)]} {
		set home "$env(HOMEDRIVE)$env(HOMEPATH)"
	    }
	}
    }

    # if there is a problem, just return current directory
    if {![file isdirectory $home]} {
	set home {.}
    }

    return $home
}

proc InitTempDir {} { 
    global ds9
    global env

    # check environment vars first
    #   windows is very picky as to file name format 
    if [info exists env(TEMP)] {
	set ds9(tmpdir) [file normalize [file nativename $env(TEMP)]]
    } elseif [info exists env(TMP)] {
	set ds9(tmpdir) [file normalize [file nativename $env(TMP)]]
    }

    #   nothing so far, go with defaults
    if {![info exists ds9(tmpdir)]} {
	global tcl_platform
	switch $tcl_platform(platform) {
	    unix {set ds9(tmpdir) "/tmp"}
	    windows {set ds9(tmpdir) "C:/WINDOWS/Temp"}
	}
    }

    #   see if it is valid, else current directory
    if {![file isdirectory $ds9(tmpdir)]} {
	set ds9(tmpdir) {.}
    }
}

proc tmpnam {base ext} {
    global ds9

    for {set ii 0} {$ii<10} {incr ii} {
	set fn "$ds9(tmpdir)/$base[clock clicks]$ext"
	if {![file exists $fn]} {
	    return $fn
	}
    }

    # give up
    return $ds9(tmpdir)/$base$ext
}

# which compiler do we use for filtering?
proc InitFilterCompiler {} {
    global ds9
    global env
    global tcl_platform
    global argv0

    # if the user did not explicitly specify one ...
    if {![info exists env(FILTER_CC)]} {
	switch -- $tcl_platform(os) {
	    Darwin {
		if {[catch {exec gcc -v} v]} {
		    # pcc is hardwired to be installed in /tmp
		    set pccroot "/tmp/pcc"
		    set pcc "$pccroot/bin/pcc"

		    if {![file exists $pcc]} {
			switch -- $tcl_platform(machine) {
			    {Power Macintosh} {set machine ppc}
			    i386 -
			    default {set machine i386}
			}
			switch [lindex [split $tcl_platform(osVersion) {.}] 0] {
			    8 {set os tiger}
			    9 {set os leopard}
			    10 -
			    default {set os snowleopard}
			}
 			set tar "pcc-$machine-$os.tar.gz"

			if [file readable "$ds9(root)/$tar"] {
			    catch {
				zvfs::filecopy "$ds9(root)/$tar" "/tmp/$tar"
				exec tar xfPz /tmp/$tar -C /tmp
				exec rm -f /tmp/$tar
			    }
			}
		    }

		    if {[file exists $pcc]} {
			set env(FILTER_CC) $pcc
			set env(FILTER_CFLAGS) "-isystem $pccroot/lib/pcc"
			set env(PATH) "$pccroot/bin:$env(PATH)"
		    }
		}
	    }

	    "Windows NT" {
		set tcc [file join [file dirname $argv0] tcc/tcc.exe]
		if [file exists $tcc] {
		    set env(FILTER_CC) [file nativename [file attributes [file normalize $tcc] -shortname]]
		    set env(FILTER_TMPDIR) [file nativename [file attributes [file normalize $ds9(tmpdir)] -shortname]]
		}
	    }
	}
    }
}

proc ToYesNo {value} {
    if {$value == 1} {
	return "yes\n"
    } else {
	return "no\n"
    }
}

proc FromYesNo {value} {
    set v [string tolower $value]

    if {$v == "no" || $v == "false" || $v == "off" || $v == 0} {
	return 0
    } else {
	return 1
    }
}

proc RealizeDS9 {} {
    # this has to come first, to realize the canvas
    global debug
    if {$debug(tcl,idletasks)} {
	puts stderr "RealizeDS9"
    }

# idletasks fails for windows. we need to process all events to make
# sure all windows are realized
#    update idletasks
    update

    # now, update all frames
    global ds9
    foreach f $ds9(frames) {
	$f update now
    }
}

proc Sex2H {str} {
    scan $str "%d:%d:%f" h m s
    return [expr $h+($m/60.)+($s/(60.*60.))]
}

proc Sex2Hs {str} {
    scan $str "%d %d %f" h m s
    return [expr $h+($m/60.)+($s/(60.*60.))]
}

proc Sex2D {str} {
    set d 0
    set arcm 0
    set arcs 0
    scan $str "%d:%f:%f" d arcm arcs

    if {$d >= 0} {
	return [expr $d+($arcm/60.)+($arcs/(60.*60.))]
    } else {
	return [expr $d-($arcm/60.)-($arcs/(60.*60.))]
    }
}

proc Sex2Ds {str} {
    set d 0
    set arcm 0
    set arcs 0
    scan $str "%d %f %f" d arcm arcs

    if {$d >= 0} {
	return [expr $d+($arcm/60.)+($arcs/(60.*60.))]
    } else {
	return [expr $d-($arcm/60.)-($arcs/(60.*60.))]
    }
}

proc SetCursor {cursor} {
    global ds9
    global iis
    global current

    # if init phase, don't change cursor
    if {$ds9(init)} {
	return
    }

    # if iis cursor mode, don't change cursor
    if {$iis(state)} {
	return
    }

    if {($current(cursor) != $cursor)} {
	set current(cursor) $cursor
	if {$cursor != {}} {
	    $ds9(canvas) configure -cursor $cursor
	} else {
	    $ds9(canvas) configure -cursor {}
	}
    }
}

proc SetWatchCursor {} {
    global ds9
    global cursor

    # if init phase, don't change cursor
    if {$ds9(init)} {
	return
    }

    # don't change cursor/update
    if {!$ds9(idletasks)} {
	return
    }

    global debug
    if {$debug(tcl,watch)} {
	puts stderr "SetWatchCursor Start $cursor(count)"
    }

    if {$cursor(count) == 0} {
	set cursor(save) [$ds9(canvas) cget -cursor]
	$ds9(canvas) configure -cursor {}
	$ds9(main) configure -cursor watch

	global debug
	if {$debug(tcl,idletasks)} {
	    puts stderr "SetWatchCursor"
	}
	update idletasks
    }
    incr cursor(count)

    if {$debug(tcl,watch)} {
	puts stderr "SetWatchCursor End $cursor(count)"
    }
}

proc UnsetWatchCursor {} {
    global ds9
    global cursor

    # if init phase, don't change cursor
    if {$ds9(init)} {
	return
    }

    # don't change cursor/update
    if {!$ds9(idletasks)} {
	return
    }

    global debug
    if {$debug(tcl,watch)} {
	puts stderr "UnsetWatchCursor Start $cursor(count)"
    }

    if {$cursor(count)>0} {
	incr cursor(count) -1
    }

    if {$cursor(count) == 0} {
	$ds9(main) configure -cursor {}
	$ds9(canvas) configure -cursor $cursor(save)

	global debug
	if {$debug(tcl,idletasks)} {
	    puts stderr "UnsetWatchCursor"
	}
	update idletasks
    }    

    if {$debug(tcl,watch)} {
	puts stderr "UnsetWatchCursor End $cursor(count)"
    }
}

proc CursorTimer {} {
    global ds9
    global cursor

    switch -- $cursor(timer) {
	0 {
	    set cursor(timer,abort) 0
	    set cursor(timer) 0
	    set cursor(id) 0
	    $ds9(canvas) configure -cursor {}
	}
	1 {
	    $ds9(canvas) configure -cursor circle
	    set cursor(timer) 2
	    set cursor(id) [after 1000 CursorTimer]
	}
	2 {
	    $ds9(canvas) configure -cursor dot
	    set cursor(timer) 1
	    set cursor(id) [after 1000 CursorTimer]
	}
    }
}

proc AboutBox {} {
    global help
    global ds9
    global ed

    set w {.abt}
    set width 400
    set height 500

    set ed(ok) 0

    DialogCreate $w [msgcat::mc {About SAOImage DS9}]

    frame $w.c -relief ridge -bd 1
    frame $w.buttons -relief ridge -bd 1
    pack $w.c $w.buttons -fill x -ipadx 4 -ipady 4

    canvas $w.c.c -background white -height $height -width $width
    pack $w.c.c
    
    # can't use -file for zvfs
    # set ed(sun) [image create photo -format gif -file $ds9(root)/doc/sun.gif]
    set ch [open $ds9(root)/doc/sun.gif r]
    fconfigure $ch -translation binary -encoding binary
    set dd [read $ch]
    close $ch
    unset ch

    set ed(sun) [image create photo -format gif -data "$dd"]
    unset dd

    $w.c.c create image 0 0 -image $ed(sun) -anchor nw
    $w.c.c create text 120 20 -text $help(about) -anchor nw

    button $w.buttons.ok -text [msgcat::mc {OK}] \
	-default active -command {set ed(ok) 1}
    grid $w.buttons.ok -padx 10

    bind $w <Return> {set ed(ok) 1}

    DialogCenter $w
    DialogWait $w ed(ok)
    DialogDismiss $w

    image delete $ed(sun)

    unset ed
}

proc QuitDS9 {} {
    global ds9
    global xpa

    if {$ds9(samp)} {
	SAMPDisconnect
    }
    catch {IISClose}
    if [info exists xpa] {
	xpafree $xpa
    }

    focus {}
    exit
}

proc OpenSource {} {
    set filename [OpenFileDialog tclfbox]
    if {$filename != {}} {
	uplevel #0 "source \{$filename\}"
    }
}

proc OpenConsole {} {
    global ds9

    if {[winfo exists ".tkcon"]} {
	tkcon show
    } else {
	set ::tkcon::OPT(exec) {}
	tkcon::Init
    }
}

proc ToggleBindEvents {} {
    global ds9

    if {$ds9(freeze)} {
	set ds9(freeze) 0
	BindEventsCanvas
	BindEventsPanner
    } else {
	set ds9(freeze) 1
	UnBindEventsCanvas
	UnBindEventsPanner
    }
}

proc ChangeMode {} {
    global ds9

    bind $ds9(canvas) <Button-1> {}
    bind $ds9(canvas) <B1-Motion> {}
    bind $ds9(canvas) <ButtonRelease-1> {}

    foreach f $ds9(frames) {
	$f crosshair off
    }
    UpdateRegionMenu

    foreach f $ds9(frames) {
	$f marker catalog unselect all
	$f marker catalog unhighlite all
	$f marker unselect all
	$f marker unhighlite all
    }

    ClearInfoBox
    PixelTableClearDialog
    ClearGraphData

    switch -- $ds9(mode) {
	none -
	pointer {SetCursor {}}
	crosshair {
	    foreach f $ds9(frames) {
		$f crosshair on
	    }
	    ShowGraphData
	    SetCursor crosshair
	}
	colorbar {
	    bind $ds9(canvas) <Button-1> {ButtonColormap %x %y}
	    bind $ds9(canvas) <B1-Motion> {MotionColormap %x %y}
	    bind $ds9(canvas) <ButtonRelease-1> {ReleaseColormap %x %y}
	    SetCursor center_ptr
	}
	zoom {SetCursor sizing}
	pan {SetCursor fleur}
	rotate {SetCursor exchange}
	examine {SetCursor target}
	illustrate {SetCursor arrow}
	catalog {SetCursor {}}
	imexam {}
    }
}

proc DisplayLog {item} {
    SimpleTextDialog ftptxt [msgcat::mc {Message Log}] 80 40 append bottom $item
}

proc ParseURL {url varname} {
    upvar $varname r

    global ds9

    set r(scheme) {}
    set r(authority) {}
    set r(path) {}
    set r(query) {}
    set r(fragment) {}
    set exp {^(([^:/?#]+):)?(//([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?}

    if {![regexp -nocase $exp $url x a r(scheme) c r(authority) r(path) f r(query) h r(fragment)]} {
	return 0
    }

    # check for windows disk drives
    global tcl_platform
    switch $tcl_platform(platform) {
	unix {}
	windows {
	    switch -- $r(scheme) {
		{} -
		ftp -
		http -
		file {
		    if [regexp {/([A-Z]:)(/.*)} $r(path) a b c] {
			set r(path) "$b$c"
		    }
		}
		default {
		    set r(path) "$r(scheme):$r(path)"
		    set r(scheme) {}
		}
	    }
	}
    }

    return 1
}

proc BreakUp {str} {
    set r {}
    set l [string length $str]
    for {set i 0} {$i < $l} {incr i} {
	set c [string index $str $i]
	append r $c
	if {$c=="\}"} {
	    append r "\n"
	}
    }
    return $r
}

proc InPath {which} {
    global env
    global tcl_platform

    switch $tcl_platform(platform) {
	unix {
	    set target ${which}
	    set paths [split $env(PATH) :]
	}
	windows {
	    set target ${which}.exe
	    set paths [split $env(PATH) \;]
	}
    }

    foreach p $paths {
	if {[file executable [file join $p $target]]} {
	    return 1
	}
    }
    return 0
}

proc FTPLog {s msg state} {
    global debug

    if {$debug(tcl,ftp)} {
	DisplayLog "$s $msg $state\n"
    }
}

proc HTTPLog {token} {
    global http
    global debug

    if {$debug(tcl,http)} {
	upvar #0 $token t

	DisplayLog "url: $t(url)\n"
	DisplayLog "http: $t(http)\n"
	DisplayLog "type: $t(type)\n"
	DisplayLog "currentsize: $t(currentsize)\n"
	DisplayLog "totalsize: $t(totalsize)\n"
	DisplayLog "status: $t(status)\n"
	if [info exists t(error)] {
	    DisplayLog "error: $t(error)\n"
	}
	DisplayLog "meta: [BreakUp $t(meta)]\n"
    }
}

proc ConfigHTTP {} {
    global http

    # set the User-Agent
    http::config -useragent ds9

    # set the proxy if requested
    if {$http(proxy)} {
	http::config -proxyhost $http(proxy,host) -proxyport $http(proxy,port)
    }
}

proc ProxyHTTP {} {
    global http

    set auth {}
    if {$http(proxy) && $http(auth)} {
	set auth [list "Proxy-Authorization" [concat "Basic" [base64::encode $http(auth,user):$http(auth,passwd)]]]
    } 

    return $auth
}

proc TmpDirOpen {varname} {
    upvar $varname var
    global $varname

    FileLast tmpdirfbox $var
    set var [file dirname [OpenFileDialog tmpdirfbox]]
}

proc ValidFits {filename} {
    if {$filename == {}} {
	return 0
    }

    # determine if its a fits file
    # first, strip the filename
    if {![regexp -nocase {(.*)(\[.*\])} $filename foo base ext]} {
	set base $filename
	set ext {}
    }

    set fd [open $base]
    if {$fd != {}} {
	set l [read $fd 9]
	close $fd
    }

    if {$l == "SIMPLE  ="} {
	return 1
    } else {
	return 0
    }
}

proc DisplayCoordDialog {which x y sys} {
    global coord

    set r {}

    foreach l {{} a b c d e f g h i j k l m n o p q r s t u v w x y z} {
	if {"$coord(wcs$l)" && [$which has wcs "wcs$l"]} {
	    set cd "[$which get coordinates $sys $x $y wcs$l $coord(sky) $coord(skyformat)]"

	    if [$which has wcs equatorial "wcs$l"] {
		append r " [lindex $cd 0] [lindex $cd 1] $coord(sky)"
	    } else {
		set name [$which get wcs name "wcs$l"]
		if {$name != {}} {
		    append r " [lindex $cd 0] [lindex $cd 1] $name"
		} else {
		    append r " [lindex $cd 0] [lindex $cd 1] [lindex $cd 3]"
		}
	    }
	}
    }

    if {$coord(detector) && [$which has detector]} {
	append r " [$which get coordinates $sys $x $y detector] detector"
    }

    if {$coord(amplifier) && [$which has amplifier]} {
	append r " [$which get coordinates $sys $x $y amplifier] amplifier"
    }

    if {$coord(physical) && [$which has physical]} {
	append r " [$which get coordinates $sys $x $y physical] physical"
    }

    if {$coord(image)} {
	append r " [$which get coordinates $sys $x $y image]"
    }

    if {$coord(value)} {
	append r " [$which get value $sys $x $y]"
    }

    append r " \n"

    SimpleTextDialog coordtxt [msgcat::mc {Coordinates}] 80 20 append bottom "$r"
}

proc FixSpec {sysname skyname formatname defsys defsky defformat} {
    upvar $sysname sys
    upvar $skyname sky
    upvar $formatname format

    set rr 0

    switch -- $sys {
	image -
	physical -
	detector -
	amplifier -
	wcs -
	wcsa -
	wcsb -
	wcsc -
	wcsd -
	wcse -
	wcsf -
	wcsg -
	wcsh -
	wcsi -
	wcsj -
	wcsk -
	wcsl -
	wcsm -
	wcsn -
	wcso -
	wcsp -
	wcsq -
	wcsr -
	wcss -
	wcst -
	wcsu -
	wcsv -
	wcsw -
	wcsx -
	wcsy -
	wcsz {incr rr}

	fk4 -
	b1950 -
	fk5 -
	j2000 -
	icrs -
	galactic -
	ecliptic {
	    set format $sky
	    set sky $sys
	    set sys wcs
	}
	
	default {
	    set format $sky
	    set sky $sys
	    set sys $defsys
	}
    }

    switch -- $sky {
	fk4 -
	b1950 -
	fk5 -
	j2000 -
	icrs -
	galactic -
	ecliptic {incr rr}

	default {
	    set format $sky
	    set sky $defsky
	}
    }

    switch -- $format {
	degrees -
	arcmin -
	arcsec -
	sexagesimal {incr rr}

	default {
	    set format $defformat
	}
    }

    return $rr
}

# Process Cmds

proc ProcessCDCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    cd [lindex $var $i]
}

proc ProcessSendCDCmd {proc id param} {
    $proc $id "[pwd]\n"
}

proc ProcessConsoleCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    OpenConsole
}

proc ProcessCursorCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    global current
    global ds9

    if {$current(frame) != {}} {
	set x [lindex $var $i]
	incr i
	set y [lindex $var $i]

	switch -- $ds9(mode) {
	    none {$current(frame) warp $x $y}
	    pointer {MarkerArrowKey $current(frame) $x $y}
	    catalog {MarkerArrowKey $current(frame) $x $y}
	    crosshair {ArrowKeyCrosshair $current(frame) $x $y}
	    colorbar {}
	    pan {Pan $x $y canvas {}}
	    zoom {}
	    rotate {}
	    examine {}
	    illustrate {}
	    imexam {}
	}
    }
}

proc ProcessSendDataCmd {proc id param sock fn} {
    global cube
    global blink
    global current

    if {$current(frame) != {}} {
	set sys [lindex $param 0]
	set sky [lindex $param 1]
	set x [lindex $param 2]
	set y [lindex $param 3]
	set w [lindex $param 4]
	set h [lindex $param 5]
	set strip [lindex $param 6]
	switch -- $sys {
	    image -
	    physical -
	    detector -
	    amplifier {
		set strip $h
		set h $w
		set w $y
		set y $x
		set x $sky
		set sky fk5
	    }

	    fk4 -
	    b1950 -
	    fk5 -
	    j2000 -
	    icrs -
	    galactic -
	    ecliptic {
		set strip $h
		set h $w
		set w $y
		set y $x
		set x $sky
		set sky $sys
		set sys wcs
	    }
	}
	set strip [FromYesNo $strip]

	$current(frame) get data $sys $sky $x $y $w $h rr
	set ss {}
	foreach ii [array names rr] {
	    if {$strip} {
		append ss "$rr($ii)\n"
	    } else {
		append ss "$ii = $rr($ii)\n"
	    }
	}
	ProcessSend $proc $id $sock $fn {.dat} $ss
    }
}

proc ProcessIconifyCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    global ds9

    switch -- [string tolower [lindex $var $i]] {
	yes -
	true -
	on -
	1 {wm iconify $ds9(top)}

	no -
	false -
	off -
	0 {wm deiconify $ds9(top)}

	default {
	    wm iconify $ds9(top)
	    incr i -1
	}
    }
}

proc ProcessSendIconifyCmd {proc id param} {
    global ds9
    if {[wm state $ds9(top)] == "normal"} {
	$proc $id "no\n"
    } else {
	$proc $id "yes\n"
    }
}

proc ProcessLowerCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    global ds9
    lower $ds9(top)
}

proc ProcessModeCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    global ds9
    set ds9(mode) [string tolower [lindex $var $i]]
    ChangeMode
}

proc ProcessQuitCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    QuitDS9
}

proc ProcessSendModeCmd {proc id param} {
    global ds9
    $proc $id "$ds9(mode)\n"
}

proc ProcessRaiseCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    global ds9
    raise $ds9(top)
}

proc ProcessSleepCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    # make sure all is visible
    update

    after [expr int([lindex $var $i]*1000)]
}

proc ProcessSourceCmd {varname iname} {
    upvar $varname var
    upvar $iname i

    # we need to be realized
    # you never know what someone will try to do
    RealizeDS9

    set fn [lindex $var $i]
    uplevel #0 "source $fn"
}

proc ProcessTclCmd {varname iname buf fn} {
    upvar $varname var
    upvar $iname i

    global ds9

    if {!$ds9(tcl)} {
	Error [msgcat::mc {Executing TCL code is not enabled}]
	return
    }

    if {$buf != {}} {
	uplevel #0 $buf
    } elseif {$fn != {}} {
	if {[file exists $fn]} {
	    set ch [open $fn r]
	    set cmd [read $ch]
	    close $ch
	    uplevel #0 $cmd
	}
    } elseif {[lindex $var $i] != {}} {
	# special case
	uplevel #0 $var
    }
}

proc ProcessSendVersionCmd {proc id param} {
    global ds9
    $proc $id "$ds9(title) [lindex $ds9(version) 0]\n"
}

proc XMLQuote {val} {
    return [string map {& &amp; < &lt; > &gt; \' &apos; \" &quot;} $val]
}

proc XMLUnQuote {val} {
    return [string map {&amp; & &lt; < &gt; > &apos; \' &quot; \"} $val]
}

